local Anim = require("lib.Animation")
local Sprite = require("lib.Sprite")
local Key = require("lib.Keyboard")
local Evt = require("lib.Events")
local GPM = require("lib.GamepadMgr")


local heroAtlas
local spr

--            (numFr, columnSize, xoffset, yoffset,  w,   h, fps)
--local idle = Anim(5, 5, 0, 0, 256, 512, 5)
local fire = Anim(2, 2, 256 * 5, 0, 256, 512, 10, false)
local idle = Anim({1, 2, 3, 4}, 8, 0, 0, 256, 512, 5)
local snd
local e

local gpm = GPM({"assets/gamecontrollerdb.txt"})


function love.load()
   Key:hookLoveEvents()
   love.graphics.setDefaultFilter('nearest', 'nearest')
   
   heroAtlas = love.graphics.newImage("assets/gfx/idleFire.png")
   
   spr = Sprite(heroAtlas, 256, 512, 256 / 2, 512 / 2, 1, 1, 3.14 * 0)
   
   spr:addAnimation("fire", fire)
   spr:addAnimation("idle", idle)
   spr:animate('idle')
   gpm.event:hook('controllerAdded', onControllerAdded)
   gpm.event:hook('controllerRemoved', onControllerRemoved)
   
   e = Evt()
   e:add('onSpace')
   e:hook('onSpace', onSpace)
  --  e:hook('onSpace', onSpace)
   
   snd = love.audio.newSource("assets/sfx/explosion.wav", "static")
end

function onControllerAdded(joyId)
   print("controller" .. joyId .. " added") 
end

function onControllerRemoved(joyId)
   print("controller" .. joyId .. " removed") 
end


function onSpace()
   print("Spaced!")
end


function love.update(dt)

   if Key:keyDown("space") and spr.currentAnim ~= "fire"  then 
      spr:animate("fire")
      love.audio.stop(snd)
      love.audio.play(snd)
--      e:invoke('onSpace')
   elseif Key:keyDown("u") then
--      e:unhook('onSpace', onSpace)
   elseif Key:keyDown("escape") then
      love.event.quit()
   end
   
   
   if spr.currentAnim == "fire" and spr:animationFinished() then
      spr:animate("idle")
   end

   if gpm:buttonDown(1, "a") then
      print("a id down")
   end
   
   Key:update(dt)
   spr:update(dt)
   gpm:update(dt)
end

function love.draw()
   spr:draw()
end

print("*********************************************************************")
